package fred;

import javax.swing.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.border.*;

import jGDK.Framstick;
import jGDK.I18N;

/**
 * <p>FramInfo.class</p>
 * <p>Dialog class letting user change the info about edited framstick.</P>
 * @author Damian Jarzebski
 * @version 1.0
 */
public class FramInfo extends JDialog implements ActionListener {
	private Framstick framstick = null;
	JLabel jLName = new JLabel();
	JTextField jTextField1 = new JTextField();
	JLabel jLAuthor = new JLabel();
	JTextField jTextField2 = new JTextField();
	JLabel jLInfo = new JLabel();
	JTextArea jTInfo = new JTextArea();
	JButton jButton = new JButton();
	TitledBorder titledBorder1;
	JScrollPane jSP = new JScrollPane();
/**
 * FramInfo constructor.
 * @param fram - framstick from whom the info will be showed.
 */
	public FramInfo(Framstick fram) {
		this.framstick = fram;
		//this.setResizable(false);
		setTitle(I18N.getMessage("FramInfo"));
		try {
			jbInit();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	/**
	 * Function main.
	 * @param args
	 * @throws HeadlessException
	 */
	public static void main(String[] args) throws HeadlessException {
		FramInfo fI = new FramInfo(null);
		fI.setSize(300,300);
		fI.setLocation(50,50);
		fI.setDefaultCloseOperation(JDialog.EXIT_ON_CLOSE);
		fI.show();
	}
	/**
	 * 
	 * @throws Exception
	 */
	private void jbInit() throws Exception {
		titledBorder1 = new TitledBorder("");
		JPanel namePanel = new JPanel();
		jLName.setHorizontalAlignment(SwingConstants.CENTER);
		jLName.setHorizontalTextPosition(SwingConstants.CENTER);
		jLName.setText(I18N.getMessage("Name")+":");
		jLName.setBounds(new Rectangle(6, 14, 63, 15));
		jLName.setBorder(BorderFactory.createEmptyBorder(0,3,0,3));
		//this.getContentPane().setLayout(null);
		jTextField1.setText("");
		jTextField1.setBounds(new Rectangle(76, 12, 200, 21));
		namePanel.setLayout(new BoxLayout((Container)namePanel,BoxLayout.X_AXIS));
		namePanel.add(jLName);
		namePanel.add(jTextField1);
		namePanel.setSize(200,30);
		JPanel authorPanel = new JPanel();
		jLAuthor.setHorizontalAlignment(SwingConstants.CENTER);
		jLAuthor.setHorizontalTextPosition(SwingConstants.CENTER);
		jLAuthor.setText(I18N.getMessage("Author")+":");
		jLAuthor.setBounds(new Rectangle(6, 49, 65, 15));
		jTextField2.setText("");
		jTextField2.setBounds(new Rectangle(76, 46, 200, 21));
		authorPanel.setLayout(new BoxLayout((Container)authorPanel,BoxLayout.X_AXIS));
		authorPanel.add(jLAuthor);
		authorPanel.add(jTextField2);
		authorPanel.setSize(200,30);
		JPanel infoPanel = new JPanel();
		jLInfo.setHorizontalAlignment(SwingConstants.CENTER);
		jLInfo.setHorizontalTextPosition(SwingConstants.CENTER);
		jLInfo.setText(I18N.getMessage("Info")+":");
		jLInfo.setBounds(new Rectangle(58, 73, 189, 15));
		jTInfo.setBorder(BorderFactory.createLoweredBevelBorder());
		jTInfo.setText("");
		infoPanel.setLayout(new BoxLayout((Container)infoPanel,BoxLayout.Y_AXIS));
		infoPanel.add(jLInfo);
		jSP.setBounds(new Rectangle(15, 95, 266, 124));
		jSP.getViewport().add(jTInfo, null);
		infoPanel.add(jSP);
		jButton.setBounds(new Rectangle(15, 231, 266, 25));
		jButton.setText(I18N.getMessage("Accept"));
		jButton.addActionListener(this);
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints cons = new GridBagConstraints();
		this.getContentPane().setLayout(gbl);
		cons.gridx=0;
		cons.gridy=0;
		cons.insets = new Insets(10,10,10,10);
		cons.weightx = 0;
		cons.weighty = 0;
		cons.fill=GridBagConstraints.HORIZONTAL;
		gbl.setConstraints(namePanel,cons);
		this.getContentPane().add(namePanel);
		//this.getContentPane().add(jTextField1, null);
		cons.gridy=1;
		gbl.setConstraints(authorPanel,cons);
		this.getContentPane().add(authorPanel);
		//this.getContentPane().add(jTextField2, null);
		cons.gridy=2;
		cons.weightx = 1;
		cons.weighty = 1;
		cons.fill=GridBagConstraints.BOTH;
		gbl.setConstraints(infoPanel,cons);
		this.getContentPane().add(infoPanel);
		cons.gridy=3;
		cons.weightx = 0;
		cons.weighty = 0;
		cons.fill=GridBagConstraints.HORIZONTAL;
		gbl.setConstraints(jButton,cons);
		this.getContentPane().add(jButton);
		//this.getContentPane().add(jSP, null);
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

		jTextField1.setText(framstick.name);
		jTextField2.setText(framstick.author);
		jTInfo.setText(framstick.info);
	}
	/**
	 * Saving all info and closing the dialog
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		framstick.name = jTextField1.getText();
		framstick.author = jTextField2.getText();
		framstick.info = jTInfo.getText();
		this.dispose();
	}
	protected void finalize() throws Throwable {
		System.out.println("Finalizing info window");
		this.getContentPane().removeAll();
		framstick = null;
		jLName = null;
		jTextField1 = null;
		jLAuthor = null;
		jTextField2 = null;
		jLInfo = null;
		jTInfo = null;
		jButton.removeActionListener(this);
		jButton = null;
		titledBorder1 = null;
		jSP = null;
		super.finalize();
	}
}