package fred;


import javax.swing.UIManager;

/**
 * <p>Title: Fred v.2.0 - Framstics Editor</p>
 * <p>Description: Framstics Virtual Organism Editor</p>
 * <p>Main class of the application starting the main window, or just showing the console
 * informations. Fires the right constructor depending of the command line parameters.</P>
 * @author Damian Jarzebski
 * @version 2.0
 */
public class Fred
{
  boolean packFrame = false;
  static String file = null;
  
  /**
   * Construct the application
   */
  public Fred()
  {
    MainFrame frame = null;
    if (file != null)
    {
      frame = new MainFrame(file);
    } else
      frame = new MainFrame();
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame)
    {
      frame.pack();
    } else
    {
      frame.validate();
    }
    //Center the window
/*		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                Dimension frameSize = frame.getSize();
                if (frameSize.height > screenSize.height) {
                        frameSize.height = screenSize.height;
                }
                if (frameSize.width > screenSize.width) {
                        frameSize.width = screenSize.width;
                }
                frame.setLocation(
                        (screenSize.width - frameSize.width) / 2,
                        (screenSize.height - frameSize.height) / 2);
 */		frame.show();
  }
  /**
   * Main method starting Fred or showing the console informations.
   */
  public static void main(String[] args)
  {
    if (args.length > 0)
    {
      if ((args[0].compareToIgnoreCase("--version") == 0)
      || (args[0].compareToIgnoreCase("-v") == 0)
      || (args[0].compareToIgnoreCase("/v") == 0))
      {
        System.out.println(
        "Fred - Framstick F0 editor\n"
        + "version 2.0\n"
        + "Authors:\n"
        + "Damian Jarzebski, Piotr Jankowski, Marcin Jurkiewicz, Cezary Dowhan\n");
        return;
      }
      if ((args[0].compareToIgnoreCase("-h") == 0)
      || (args[0].compareToIgnoreCase("/?") == 0)
      || (args[0].compareToIgnoreCase("/h") == 0)
      || (args[0].compareToIgnoreCase("-help") == 0)
      || (args[0].compareToIgnoreCase("--help") == 0)
      || (args[0].compareToIgnoreCase("/help") == 0))
      {
        System.out.println(
        "Fred - Framstick f0 editor\n\n"
        + "usage:\n"
        + "Fred\n"
        + "Fred <gen-file>\n"
        + "Fred <-h></h><-help><--help></help>\n"
        + "Fred <-v></v><--version>\n");
        return;
      } else
      {
        if (args[0].endsWith(".gen"))
        {
          file = new String(args[0]);
        } else
        {
          System.out.println("Wrong parameter!");
          return;
        }
      }
    }
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch (Exception e)
    {
      System.out.println("Unable to set look and Feel");
    }
    new Fred();
  }
}