package fred;

import java.io.File;

import javax.swing.filechooser.FileFilter;
/**
 * <p>GenFileFilter class</p>
 * Class that filters the files showed in Open and Close dialogs.
 * @author Damian Jarzebski
 * @version 2.0
 */
public class GenFileFilter extends FileFilter {
/**
 * The file has correct extension or not.
 */
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = getExtension(f);
        if (extension != null) {
            if (extension.equals("gen")) {
                    return true;
            } else {
                return false;
            }
        }

        return false;
    }
/**
 * Gets the extension from the file.
 * @param f
 * @return
 */
	public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
/**
 * Gtes description of showed file in Open/close dialogs.
 */
    public String getDescription() {
        return "Genotype pool (*.gen)";
    }
}