package fred;

import java.awt.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;

import java.beans.*;
import java.util.*;
import java.io.*;
import java.net.*;
import jGDK.I18N;

public class Help extends JInternalFrame
{
  JEditorPane html;
  Vector History = new Vector();
  int pcount = -1;
  int ppos = -1;
  public Help()
  {
    this.setIconifiable(false);
    this.setMaximizable(true);
    this.setResizable(true);
    this.setClosable(true);
    //----------------
    
    JScrollPane scroller = new JScrollPane();
    
    try
    {
      String filename = "html/index.html";
      URL url;
      url = ClassLoader.getSystemResource(filename);
      String path = null;
      try
      {}
      catch (Exception e)
      {
        System.err.println("Failed to open:" + path + ";");
        url = null;
      }
      
      if (url != null)
      {
        html = new JEditorPane(url);
        html.setEditable(false);
        html.addHyperlinkListener(createHyperLinkListener());
        
        html.setSize(300, 100);
        scroller.getViewport().add(html);
      }
    }
    catch (MalformedURLException e)
    {
      System.out.println("Malformed URL: " + e);
    }
    catch (IOException e)
    {
      System.out.println("IOException: " + e);
    }
    
    //----------------
    //Display the window.
    Dimension screensize = Toolkit.getDefaultToolkit().getScreenSize();
    int cx = (int)screensize.getWidth();
    int cy = (int)screensize.getHeight();
    int x = cx - 300;
    int y = cy - 300;
    
    this.setTitle("Fred 2.1 "+I18N.getMessage("Help"));
    this.setSize(x, y);
    scroller.setPreferredSize(new Dimension(this.getSize().width, this.getSize().height));
    this.getContentPane().setLayout(new BorderLayout());
    
    this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    
    //	frame.getContentPane().add(tb1,  BorderLayout.NORTH);
    this.getContentPane().add(scroller, BorderLayout.CENTER);
    
    this.pack();
    this.setLocation((int)Math.round((cx - x) / 2), (int)Math.round((cy - y) / 2));
    this.setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
    
  }
  
  public HyperlinkListener createHyperLinkListener()
  {
    return new HyperlinkListener()
    {
      public void hyperlinkUpdate(HyperlinkEvent e)
      {
        if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
        {
          if (e instanceof HTMLFrameHyperlinkEvent)
          {
            ((HTMLDocument)html.getDocument()).processHTMLFrameHyperlinkEvent((HTMLFrameHyperlinkEvent)e);
            if (pcount > ppos)
              pcount = ppos;
            pcount++;
            ppos++;
            
            History.add(ppos, e.getURL().toString());
//            System.out.println("h.a:" + e.getURL() + " pc:" + pcount + " pp:" + ppos);
            
          }
          else
          {
            
            try
            {
              
              html.setPage(e.getURL());
              
            }
            catch (IOException ioe)
            {
              System.out.println("IOE: " + ioe);
            }
          }
        }
      }
    };
  }
  
  public static void main(String s[])
  {
    Help h = new Help();
    JFrame f = new JFrame("Fred - Main this");
    f.setSize(h.getSize().width + 10, h.getSize().height + 30);
    f.getContentPane().setLayout(null);
    f.setLocation(50, 20);
    f.setVisible(true);
    f.getContentPane().add(h);
    h.show();
    try
    {
      h.setMaximum(true);
    }
    catch (PropertyVetoException ex)
    {
      System.out.println("Cannot resize the window");
    }
  }
}
