/*
 * Created on 2003-06-21
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package fred;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

/**
 * <p>LoadWindow class</p>
 * <p>Small class showing the loading window. Instances of this class are created only 
 * for loading time.</P>
 * @author Damian Jarzbski
 */
public class LoadWindow extends Thread implements Runnable {
	private String title = null;
	Dimension d = new Dimension();
	JDialog f = null;
	boolean showing = false;
	boolean created = false;

	private String text = null;
	/**
	 * Constructor of this class. Setting title of the window to "Loading..." and the internal text
	 *  to "starting up...".
	 */
	public LoadWindow() {
		super();
		title = "Loading...";
		text = "starting up...";
		init();
	}
	/**
	 * Constructor of this class. Setting the internal text
	 *  to <CODE>name</CODE>.
	 * @param name
	 */
	public LoadWindow(String text) {
		super();
		title = "Loading...";
		this.text = text;
		init();
	}
	/**
	 * Constructor of this class. Setting title of the window to <CODE>title</CODE> and the internal text
	 *  to <CODE>text</CODE>.
	 * @param title
	 * @param text
	 */
	public LoadWindow(String title, String text) {
		super();
		this.title = title;
		this.text = text;
		init();
	}
	private void init() {
		d = Toolkit.getDefaultToolkit().getScreenSize();
		f = new JDialog();
		created = true;
	}
	/**
	 * Function repaints the window once for sekond.
	 */
	public void run() {
		try {
			if (created) {
				if (!showing) {
					f.setTitle(title);
					JLabel l1 = new JLabel(text);
					l1.setHorizontalAlignment(SwingConstants.CENTER);
					l1.setHorizontalTextPosition(SwingConstants.CENTER);
					l1.setFont(new Font("Arial", Font.BOLD, 18));
					f.getContentPane().add(l1);
					f.setSize(200, 100);
					d.width = (d.width - f.getSize().width) / 2;
					d.height = (d.height - f.getSize().height) / 2;
					f.setLocation(d.width, d.height);
					f.show();
					showing = true;
				}
				else {
					f.repaint();
					try {
						Thread.sleep(1000);
					}
					catch (InterruptedException e) {
						// the VM doesn't want us to sleep anymore,
						// so get back to work
					}
				}
			}
		}
		catch (NullPointerException e) {}
	}
	/**
	 * Kills the window
	 */
	public void destroy() {
		if (f != null) {
			f.getContentPane().removeAll();
			f.dispose();
			f = null;
		}
		System.runFinalization();
	}
	/**
	 * Main function to test this class.
	 * @param args
	 */
	public static void main(String[] args) {
		LoadWindow lw = new LoadWindow("Working...");
		lw.start();
	}
	protected void finalize() throws Throwable {
		System.out.println("Finalizing load window");
		if(f!=null)f.getContentPane().removeAll();
		title = null;
		d = null;
		f = null;
		text = null;
		super.finalize();
	}
}
