package fred;

import jGDK.I18N;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

/**
 * AboutBox class. Displaing information about authors.
 * @author Damian Jarzebski
 * @version 2.0
 */

public class MainFrame_AboutBox extends JDialog implements ActionListener
{
  JButton button1 = new JButton();
  JLabel imageLabel = new JLabel();
  ImageIcon image1 = new ImageIcon();
  public MainFrame_AboutBox(Frame parent)
  {
    super(parent);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.setTitle(I18N.getMessage("About"));
    
    image1 = new ImageIcon(ClassLoader.getSystemResource("images/fred.gif"));
    imageLabel.setIcon(image1);
    imageLabel.setBorder(BorderFactory.createEmptyBorder(15,15,15,15));
    
    JTextPane tf=new JTextPane();
    tf.setEnabled(false);
    tf.setBackground(getBackground());
    
    String[] str =
    { I18N.getMessage("FredTitle"),
      "\nCopyright (c) 2003, 2004",
      "\n\nwww.frams.alife.pl\n\n"+ I18N.getMessage("OpenSource")+"\n\n",
      I18N.getMessage("authors"),
      "\nCezary Dowhan\nPiotr Jankowski\nDamian Jarzebski\nMarcin Jurkiewicz\n\n",
      I18N.getMessage("mentor"),
      "\nMaciej Komosinski\nSzymon Ulatowski\n",
    };
    
    String[] sty = { "large","bold","regular", "bold","regular", "bold", "regular"  };
    
    StyledDocument doc = tf.getStyledDocument();
    Style def = StyleContext.getDefaultStyleContext().
    getStyle(StyleContext.DEFAULT_STYLE);
    
    Style regular = doc.addStyle("regular", def);
    StyleConstants.setFontFamily(def, "SansSerif");
    
    Style s = doc.addStyle("bold", regular);
    StyleConstants.setBold(s, true);
    
    s = doc.addStyle("large", regular);
    StyleConstants.setFontSize(s, 24);
    
    try
    {
      for (int i=0; i < str.length; i++)
        doc.insertString(doc.getLength(), str[i], doc.getStyle(sty[i]));
    } catch (BadLocationException ble)
    {
      System.err.println("Couldn't insert text into text pane.");
    }
    
    tf.setBorder(BorderFactory.createEmptyBorder(15,15,15,15));
    
    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(imageLabel, BorderLayout.WEST);
    getContentPane().add(tf, BorderLayout.EAST);
    getContentPane().add(button1, BorderLayout.SOUTH);
    
    button1.setText("OK");
    button1.addActionListener(this);
    
    setResizable(false);
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e)
  {
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      cancel();
    }
    super.processWindowEvent(e);
  }
  //Close the dialog
  void cancel()
  {
    dispose();
  }
  //Close the dialog on a button event
  public void actionPerformed(ActionEvent e)
  {
    if (e.getSource() == button1)
    {
      cancel();
    }
  }
  public static void main(String[] args)
  {
    I18N in = new I18N("", "");
    MainFrame_AboutBox a = new MainFrame_AboutBox(null);
    a.pack();
    a.show();
  }
}