package fred;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.*;

import jGDK.ErrManager;
import jGDK.Framstick;
import jGDK.GenotypeParser;
import jGDK.Library;
import jGDK.Record;
import jGDK.FramstickListener;
import jGDK.FramstickEvent;
import jGDK.I18N;

public class Prop extends JInternalFrame implements FocusListener, ActionListener
{
  Vector zakladki;
  Hashtable pola;
  Vector temp;
  JTabbedPane tabbedPane;
  Record record;
  String param;
  boolean zmiana = false;
  String neurontype;
  int position = 0;
  int reN;
  Framstick f;
  MyFramstickListener myFL = new MyFramstickListener();
  Library l;
  String type;
  GridBagLayout gridBLayout = new GridBagLayout();
  GridBagConstraints constr = new GridBagConstraints();
  
  public Prop(Framstick fr, String typ, int refN)
  {
    this.setResizable(false);
    this.setClosable(true);
    switch (typ.charAt(0))
    {
      case 'p' :
        this.setTitle(I18N.getMessage("propProp") + " Part#" + refN);
        break;
      case 'j' :
        this.setTitle(I18N.getMessage("propProp") + " Joint#" + refN);
        break;
      case 'c' :
        this.setTitle(I18N.getMessage("propProp") + " Connection#" + refN);
        break;
      case 'n' :
        this.setTitle(I18N.getMessage("propProp") + " Neuron#" + refN);
        break;
    }
    
    reN = refN;
    f = fr;
    f.addFramstickListener(myFL);
    
    l = Framstick.library;
    type = typ;
    tabbedPane = new JTabbedPane();
    temp = new Vector();
    
    bud_wekt();
    bud_zakl();
    
    JButton app = new JButton(I18N.getMessage("apply"));
    this.getContentPane().add(app, BorderLayout.SOUTH);
    app.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        boolean test = false;
        for (int k = 0; k < zakladki.size(); k++)
        {
          String group = (String)zakladki.elementAt(k);
          for (int i = 0; i < ((Vector)pola.get(group)).size() / 5; i++)
          {
            String hh = ((JTextField) ((JPanel)tabbedPane.getComponentAt(k)).getComponent(i * 2 + 1)).getText();
            String typeOF = ((String) ((Vector)pola.get(group)).elementAt(i * 5 + 1));
            //type of empty string is ok
            if (hh.compareTo("") != 0)
            {
              if (typeOF.compareTo("d") == 0)
              {
                try
                { //double
                  int ww = Integer.parseInt(hh);
                }
                catch (Exception e2)
                {
                  Object[] inon =
                  { "" + ((Vector)pola.get(group)).elementAt(i * 5)};
                  ErrManager.send(ErrManager.ER_ERROR, group + ": " + I18N.getFormated("propShouI", inon));
                  test = true;
                }
              }
              
              if (typeOF.compareTo("f") == 0)
              {
                try
                { //double blad bylo a powinno byc float
                  float ww = Float.parseFloat(hh);
                }
                catch (Exception e2)
                {
                  Object[] inon =
                  { "" + ((Vector)pola.get(group)).elementAt(i * 5)};
                  ErrManager.send(ErrManager.ER_ERROR, group + ": " + I18N.getFormated("propShouF", inon));
                  test = true;
                }
              }
            }
          }
          
        }
        
        if (zmiana)
        {
          try
          {
            ((Hashtable)f.getNeuroProp(reN, "info")).clear();
          }
          catch (Exception e3)
          {}
          
          ((Hashtable)f.getNeuroProp(reN, "info")).put("declared", new Vector());
          zmiana = false;
          
        }
        if (!test)
        {
          String group = "";
          for (int k = 0; k < zakladki.size(); k++)
          {
            group = (String)zakladki.elementAt(k);
            //wypelnij_default_puste(group);
            for (int i = 0; i < ((Vector)pola.get(group)).size() / 5; i++)
            {
              Object input = null;
              String typ = (String) ((Vector)pola.get(group)).elementAt(i * 5 + 1);
              String curval = ((JTextField) ((JPanel)tabbedPane.getComponentAt(k)).getComponent(i * 2 + 1)).getText();
              String defval = " " + ((Vector)pola.get(group)).elementAt(i * 5 + 3);
              defval = defval.substring(1, defval.length());
              String nameId = (String) ((Vector)pola.get(group)).elementAt(i * 5);
              String wrival = " " + ((Vector)pola.get(group)).elementAt(i * 5 + 2);
              wrival = wrival.substring(1, wrival.length());
              
              if (curval.length() != 0)
              {
                if (typ.compareTo("s") == 0)
                  input = (String)curval;
                if (typ.compareTo("d") == 0)
                {
                  int kk = Integer.parseInt(((String)curval));
                  
                  //input=kk.;
                  input = new Integer(Integer.parseInt(((String)curval)));
                }
                if (typ.compareTo("f") == 0)
                  input = new Float(Float.parseFloat((String)curval));
                
              }
              else
              {
                if (type.compareTo("p") == 0)
                {
                  f.delPartProp(reN, nameId);
                }
                if (type.compareTo("j") == 0)
                {
                  f.delJointProp(reN, nameId);
                }
                if (type.compareTo("c") == 0)
                {
                  f.delConnProp(reN, nameId);
                }
                if (type.compareTo("n") == 0)
                {
                  if (group.compareTo("Other") == 0 && nameId.compareTo("d") != 0)
                  {
                    try
                    {
                      int yw = ((Hashtable)f.getNeuroProp(reN, "info")).size();
                    }
                    catch (Exception e1)
                    {}
                    
                    if (((Hashtable)f.getNeuroProp(reN, "info")).containsKey(nameId))
                    {
                      ((Hashtable)f.getNeuroProp(reN, "info")).remove(nameId);
                      
                      //BLEDY										//usunac declared
                      ((Vector) ((Hashtable)f.getNeuroProp(reN, "info")).get("declared")).remove(nameId);
                      
                    }
                    
                  }
                  else
                  {
                    f.delNeuroProp(reN, nameId);
                    
                  }
                  
                }
                ((Vector)pola.get(group)).set(i * 5 + 2, null);
              }
              
              if (input != null)
              {
                if (type.compareTo("p") == 0 && curval.compareTo(wrival) != 0 && !(wrival == null && curval.compareTo(wrival) == 0))
                {
                  f.setPartProp(reN, nameId, input);
                  ((Vector)pola.get(group)).set(i * 5 + 2, input);
                }
                if (type.compareTo("j") == 0 && curval.compareTo(wrival) != 0 && !(wrival == null && curval.compareTo(wrival) == 0))
                {
                  f.setJointProp(reN, nameId, input);
                  ((Vector)pola.get(group)).set(i * 5 + 2, input);
                }
                if (type.compareTo("c") == 0 && curval.compareTo(wrival) != 0 && !(wrival == null && curval.compareTo(wrival) == 0))
                {
                  f.setConnProp(reN, nameId, input);
                  ((Vector)pola.get(group)).set(i * 5 + 2, input);
                }
                
                if (type.compareTo("n") == 0 && curval.compareTo(wrival) != 0 && !(wrival == null && curval.compareTo(wrival) == 0))
                {
                  
                  if (group.compareTo("Other") == 0 && nameId.compareTo("d") != 0)
                  {
                    
                    if (((Hashtable)f.getNeuroProp(reN, "info")) != null)
                    {
                      ((Hashtable)f.getNeuroProp(reN, "info")).put(nameId, input);
                    }
                    else
                    {
                      
                      ((Hashtable)f.getNeuroProp(reN, "info")).put(nameId, input);
                    }
                    
                    //dodac declared
                    if (!(((Vector) ((Hashtable)f.getNeuroProp(reN, "info")).get("declared")).contains(nameId)))
                    {
                      ((Vector) ((Hashtable)f.getNeuroProp(reN, "info")).get("declared")).add(nameId);
                      
                    }
                  }
                  else
                  {
                    f.setNeuroProp(reN, nameId, input);
                  }
                  
                  ((Vector)pola.get(group)).set(i * 5 + 2, input);
                  
                }
                
              }
            }
            
          }
          
          f.recountCoordinates();
          
          f.fireSignificantEditEvent();
          
        }
        
      }
    });
    
    this.setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
    
  }
  //******************************************************************************************
  private void bud_zakl()
  {
    tabbedPane.setTabPlacement(JTabbedPane.LEFT);
    Component panel1;
    for (int i = 0; i < zakladki.size(); i++)
    {
      ImageIcon icon = new ImageIcon("images/" + (String)zakladki.elementAt(i) + ".gif");
      panel1 = null;
      panel1 = makeTextPanel((String)zakladki.elementAt(i));
      String tem = "";
      for (int k = 0; k < ((Vector)pola.get((String)zakladki.elementAt(i))).size() / 5; k++)
      {
        if (k == 0)
          tem = tem + ((Vector)pola.get((String)zakladki.elementAt(i))).get(k * 5);
        else
          tem = tem + ", " + ((Vector)pola.get((String)zakladki.elementAt(i))).get(k * 5);
      }
      tabbedPane.addTab((String)zakladki.elementAt(i), icon, panel1, tem);
      wypelnij_wartosciami((String)zakladki.elementAt(i));
    }
    tabbedPane.setSelectedIndex(0);
    this.getContentPane().setLayout(new BorderLayout());
    this.getContentPane().add(tabbedPane, BorderLayout.CENTER);
    
  }
  //******************************************************************************************
  private void bud_wekt()
  {
    pola = new Hashtable();
    zakladki = new Vector();
    int position = 0;
    record = l.getRecord("class", type);
    String name = new String();
    while ((param = record.getParamAtPos(position)) != null)
    {
      position++;
      String group = (String)record.getParamProperty(param, "group");
      if (!zakladki.contains(group))
        zakladki.addElement(group);
      if (!pola.containsKey(group))
        pola.put(group, new Vector());
      String type_v = (String)record.getParamProperty(param, "type");
      name = (String)record.getParamProperty(param, "name");
      Object value = new Object();
      if (type.compareTo("j") == 0)
        value = f.getJointProp(reN, param);
      if (type.compareTo("p") == 0)
        value = f.getPartProp(reN, param);
      if (type.compareTo("c") == 0)
        value = f.getConnProp(reN, param);
      if (type.compareTo("n") == 0)
        value = f.getNeuroProp(reN, param);
      if (type.compareTo("n") == 0 && group.compareTo("Other") == 0 && ((Vector)pola.get("Other")).size() == 0)
      {
        neurontype = (String)value;
      };
      ((Vector)pola.get(group)).add(param);
      ((Vector)pola.get(group)).add(type_v);
      ((Vector)pola.get(group)).add(value);
      ((Vector)pola.get(group)).add(name);
      
    }
    
    //***************************
    int pos = 0;
    if (type.compareTo("n") == 0)
    {
      Record record1 = l.getRecord("neuro", (String)f.getNeuroProp(reN, "d"));
      while ((param = record1.getParamAtPos(pos)) != null)
      {
        pos++;
        String group = "Other";
        ;
        if (!zakladki.contains(group))
          zakladki.addElement(group);
        if (!pola.containsKey(group))
          pola.put(group, new Vector());
        String type_v = (String)record1.getParamProperty(param, "type");
        name = (String)record1.getParamProperty(param, "name");
        Object def = record1.getParamProperty(param, "def");
        Object value = new Object();
        value = null;
        
        //))))))))))))))))))))))))))))))))))))))))))))))))))))))))))00000000000000000000000000000
        try
        {
          if (((Hashtable)f.getNeuroProp(reN, "info")).containsKey(param))
            value = ((Hashtable)f.getNeuroProp(reN, "info")).get(param);
          ; //((Hashtable)f.getNeuroProp(reN, "info")).get("param");
        }
        catch (Exception e2)
        {
          
          ((Hashtable)f.getNeuroProp(reN, "info")).put("declared", new Vector());
        }
        
        ((Vector)pola.get(group)).add(param);
        ((Vector)pola.get(group)).add(type_v);
        ((Vector)pola.get(group)).add(value);
        ((Vector)pola.get(group)).add(name);
        ((Vector)pola.get(group)).add(def); //POWINNO BYC DEFAULT
      }
      
    }
    
    //***************************
    //zczytanie prawdziwych defaultow
    for (int x = 0; x < l.database.size(); x++)
    {
      Record a = (Record)l.database.get(x);
      String t = (String)a.getInfoAbout("id");
      if (t.compareTo(type) == 0)
      {
        Vector tempor = new Vector();
        for (int y = 0; y < (a.parameters).size(); y++)
        {
          Object _def = null;
          String _id = null;
          String _group = null;
          _def = (((Hashtable)a.parameters.elementAt(y)).get("def"));
          _id = " " + (((Hashtable)a.parameters.elementAt(y)).get("id"));
          _id = _id.substring(1, _id.length());
          _group = " " + (((Hashtable)a.parameters.elementAt(y)).get("group"));
          _group = _group.substring(1, _group.length());
          int kt = ((Vector)pola.get(_group)).indexOf(_id) / 4;
          kt = ((Vector)pola.get(_group)).indexOf(_id) + 4;
          if (kt > ((Vector)pola.get(_group)).size())
          {
            ((Vector)pola.get(_group)).add(kt, null);
            ((Vector)pola.get(_group)).set(kt, _def);
          }
          else
            ((Vector)pola.get(_group)).add(kt, _def);
        }
        
      }
    }
    
    if (type.compareTo("n") == 0)
    {
      ((Vector)pola.get("Other")).set(4, neurontype);
    }
    
  }
  //******************************************************************************************
  
  protected void update()
  {
    int ile = 0;
    switch (type.charAt(0))
    {
      case 'p' :
        ile = f.getPartCount();
        break;
      case 'j' :
        ile = f.getJointCount();
        break;
      case 'c' :
        ile = f.getConnCount();
        break;
      case 'n' :
        ile = f.getNeuroCount();
        break;
    }
    
    if (ile - 1 < reN)
    {
      this.dispose();
      return;
    }
    
    //	bud_zakl();
    switch (type.charAt(0))
    {
      case 'p' :
        bud_wekt();
        for (int y = 0; y < zakladki.size(); y++)
          wypelnij_wartosciami((String)zakladki.elementAt(y));
        break;
      case 'j' :
        bud_wekt();
        for (int y = 0; y < zakladki.size(); y++)
          wypelnij_wartosciami((String)zakladki.elementAt(y));
        break;
      case 'c' :
        bud_wekt();
        for (int y = 0; y < zakladki.size(); y++)
          wypelnij_wartosciami((String)zakladki.elementAt(y));
        break;
      case 'n' :
        
        if (((String)f.getNeuroProp(reN, "d")).compareTo(neurontype) == 0)
        {
          
          bud_wekt();
          
          for (int y = 0; y < zakladki.size(); y++)
            wypelnij_wartosciami((String)zakladki.elementAt(y));
          return;
        }
        
        int ktory = zakladki.indexOf("Other");
        int ktory2 = ((Vector)pola.get("Other")).indexOf("d");
        ((JTextField) ((JPanel)tabbedPane.getComponentAt(ktory)).getComponent(ktory2 * 2 + 1)).setText(((String)f.getNeuroProp(reN, "d")));
        bud_other_neuron();
        
        bud_wekt();
        
        for (int y = 0; y < zakladki.size(); y++)
          wypelnij_wartosciami((String)zakladki.elementAt(y));
        
        break;
        
    }
    
  }
  
  //******************************************************************************************
  private void bud_other_neuron()
  {
    //SPRAWDZANIE POLA d CZY ISTNIEJE TAKI NEURON-MOZE DOMYSLNIE LISTA ROZWIJANA!!!!!!!!
    int pos = 0;
    int ktory = zakladki.indexOf("Other");
    int ktory2 = ((Vector)pola.get("Other")).indexOf("d");
    String kind = ((JTextField) ((JPanel)tabbedPane.getComponentAt(ktory)).getComponent(ktory2 * 2 + 1)).getText();
    
    //testing d if is not incorrect
    if (l.getRecord("neuro", kind) == null)
    {
      
      ErrManager.send(this.getTitle(), ErrManager.ER_ERROR, I18N.getMessage("propBONE"));
      ((JTextField) ((JPanel)tabbedPane.getComponentAt(ktory)).getComponent(ktory2 * 2 + 1)).setText(
      "" + ((Vector)pola.get("Other")).elementAt(ktory2 + 4));
      return;
    }
    
    if (neurontype.compareTo(kind) == 0)
      return;
    neurontype = kind;
    ((Vector)pola.get("Other")).set(ktory2 + 4, neurontype);
    //BLEDY
    
    zmiana = true;
    
    f.setNeuroProp(reN, (String) ((Vector)pola.get("Other")).elementAt(0), neurontype);
    ((JTextField) ((JPanel)tabbedPane.getComponentAt(ktory)).getComponent(ktory2 * 2 + 1)).removeActionListener(this);
    ((JTextField) ((JPanel)tabbedPane.getComponentAt(ktory)).getComponent(ktory2 * 2 + 1)).removeFocusListener(this);
    tabbedPane.removeTabAt(ktory);
    Vector tem1 = new Vector();
    tem1.add(((Vector)pola.get("Other")).elementAt(0));
    tem1.add(((Vector)pola.get("Other")).elementAt(1));
    tem1.add(((Vector)pola.get("Other")).elementAt(2));
    tem1.add(((Vector)pola.get("Other")).elementAt(3));
    tem1.add(((Vector)pola.get("Other")).elementAt(4));
    ((Vector)pola.get("Other")).clear();
    ((Vector)pola.get("Other")).add(tem1.elementAt(0));
    ((Vector)pola.get("Other")).add(tem1.elementAt(1));
    ((Vector)pola.get("Other")).add(kind);
    ((Vector)pola.get("Other")).add(tem1.elementAt(3));
    ((Vector)pola.get("Other")).add(tem1.elementAt(4));
    
    pos = 0;
    Record record1 = l.getRecord("neuro", kind);
    while ((param = record1.getParamAtPos(pos)) != null)
    {
      pos++;
      String group = "Other";
      ;
      String type = (String)record1.getParamProperty(param, "type");
      String name = (String)record1.getParamProperty(param, "name");
      Object value = new Object();
      Object def = record1.getParamProperty(param, "def");
      value = null;
      //value = f.getNeuroProp(reN, param);
      ((Vector)pola.get(group)).add(param);
      ((Vector)pola.get(group)).add(type);
      ((Vector)pola.get(group)).add(value);
      ((Vector)pola.get(group)).add(name);
      ((Vector)pola.get(group)).add(def); //ALE POWINNO BYC DEFAULT
      
    }
    
    Component panel1;
    ImageIcon icon = new ImageIcon("images/" + (String)zakladki.elementAt(ktory) + ".gif");
    panel1 = null;
    panel1 = makeTextPanel((String)zakladki.elementAt(ktory));
    String tem = "";
    for (int k = 0; k < ((Vector)pola.get((String)zakladki.elementAt(ktory))).size() / 5; k++)
    {
      if (k == 0)
        tem = tem + ((Vector)pola.get((String)zakladki.elementAt(ktory))).get(k * 5);
      else
        tem = tem + ", " + ((Vector)pola.get((String)zakladki.elementAt(ktory))).get(k * 5);
    }
    
    tabbedPane.insertTab((String)zakladki.elementAt(ktory), icon, panel1, tem, ktory);
    wypelnij_wartosciami((String)zakladki.elementAt(ktory));
    
    tabbedPane.setSelectedIndex(ktory);
    ((JTextField) ((JPanel)tabbedPane.getComponentAt(ktory)).getComponent(ktory2 * 2 + 1)).transferFocus();
    this.pack();
    
  }
  //******************************************************************************************
  private void wypelnij_wartosciami(String group)
  {
    String prop = new String();
    for (int i = 0; i < ((Vector)pola.get(group)).size() / 5; i++)
    {
      int ktory = zakladki.indexOf(group);
      prop = " " + ((Vector)pola.get(group)).elementAt(i * 5 + 2);
      prop = prop.substring(1, prop.length());
      if (prop.compareTo("null") == 0)
        prop = "";
      ((JTextField) ((JPanel)tabbedPane.getComponentAt(ktory)).getComponent(i * 2 + 1)).setText(prop);
    }
  }
  //******************************************************************************************
  private void wypelnij_default(String group)
  {
    String prop = new String();
    for (int i = 0; i < ((Vector)pola.get(group)).size() / 5; i++)
    {
      int ktory = zakladki.indexOf(group);
      prop = " " + ((Vector)pola.get(group)).elementAt(i * 5 + 4);
      prop = prop.substring(1, prop.length());
      if (prop.compareTo("null") == 0)
        prop = "";
      ((JTextField) ((JPanel)tabbedPane.getComponentAt(ktory)).getComponent(i * 2 + 1)).setText(prop);
    }
  }
  //******************************************************************************************
  private Component makeTextPanel(final String group)
  {
    JPanel panel = new JPanel();
    JLabel lab = new JLabel();
    //pole= new JTextField(10);
    panel.setLayout(gridBLayout);
    for (int i = 0; i < ((Vector)pola.get(group)).size() / 5; i++)
    {
      lab = new JLabel(" " + (String) ((Vector)pola.get(group)).elementAt(i * 5) + " ");
      lab.setToolTipText((String) ((Vector)pola.get(group)).elementAt(i * 5 + 3));
      JTextField pole = new JTextField(7);
      pole.setToolTipText((String) ((Vector)pola.get(group)).elementAt(i * 5 + 3));
      if (type.compareTo("n") == 0 && group.compareTo("Other") == 0 && ((String) ((Vector)pola.get(group)).elementAt(i * 5)).compareTo("d") == 0)
      {
        pole.addFocusListener(this);
        pole.addActionListener(this);
      }
      
      constr.gridx = 0;
      constr.gridy = i;
      constr.ipadx = 0;
      constr.ipady = 0;
      gridBLayout.setConstraints(lab, constr);
      panel.add(lab);
      
      constr.gridx = 1;
      constr.gridy = i;
      constr.ipadx = 0;
      constr.ipady = 0;
      gridBLayout.setConstraints(pole, constr);
      panel.add(pole);
      
    }
    
    JButton def = new JButton(I18N.getMessage("default"));
    constr.gridx = 0;
    constr.gridy = ((Vector)pola.get(group)).size() / 5 + 1;
    constr.ipadx = 0;
    constr.ipady = 0;
    constr.fill = GridBagConstraints.BOTH;
    constr.gridheight = 1;
    constr.gridwidth = 2;
    gridBLayout.setConstraints(def, constr);
    panel.add(def);
    constr.gridheight = 1;
    constr.gridwidth = 1;
    def.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        wypelnij_default(group);
      }
    });
    
    return panel;
  }
  //******************************************************************************************
  
  public void focusGained(FocusEvent e)
  {}
  
  public void focusLost(FocusEvent e)
  {
    bud_other_neuron();
  }
  
  public void actionPerformed(ActionEvent e)
  {
    bud_other_neuron();
  }
  
  public static void main(String[] args)
  {
    //jGDK-----------
    ErrManager err = new ErrManager();
    Library library = null;
    try
    {
      File f = new File("model.def");
      if (!f.exists())
      {
        System.out.println("The config file don't exist: " + "model.def");
        return;
      }
      if (!f.canRead())
      {
        System.out.println("There is no access to the config file: " + "model.def");
        return;
      }
      InputStream input = new FileInputStream(f);
      int n = input.available();
      byte buf[] = new byte[n];
      if ((n = input.read(buf)) >= 0)
      {
        System.out.println("The config file has been read");
      }
      input.close();
      library = new Library(new String(buf));
    }
    catch (IOException ex)
    {
      System.out.println("ERROR: " + ex.getLocalizedMessage());
    }
    Framstick.library = library;
    GenotypeParser.library = library;
    Framstick fram = new Framstick();
    fram.genotype =
    "//0\np:0,0,0,ing=1\np:x=10,y=0,z=0,ing=0.5\np:2,0,0,ing=0.1\np:1,1,0,ing=0\nj:0,1,dx=0.1,dy=0.2,dz=0.3,rx=0.1,ry=0.2,rz=0.3,stam=0.1,rotstif=0.2,stif=0.3\n\nj:1,3\nj:2,1\nn:3,d=\"|:p=0.772672,r=0.333333\"\nn:0,d=\"@:p=0.475\"\nn:p=1,d=\"N:in=0.199,1.22,1.44,0.32\"\nn:1,d=\"Sin:f0=0.1\"\nc:0,1,0.3";
    fram.rebuildModel();
    
    //jGDK-----------END
    System.out.println(fram.toString());
    JFrame f = new JFrame("Main window");
    f.setSize(300, 300);
    Prop tab = new Prop(fram, "n", 1);
    tab.pack();
    f.setLocation(100, 100);
    f.getContentPane().add(tab);
    tab.setVisible(true);
    f.show();
    
                /*  //------------------
                        Prop tab1= new Prop(fram,"j",0);
                                tab1.addWindowListener(new WindowAdapter() {
                      public void windowClosing(WindowEvent e) {System.exit(0);}
                      });
                                tab1.setVisible(true);
                                tab1.pack()	;
                                tab1.setLocation(100,100);
                  //------------------
                        Prop tab2= new Prop(fram,"n",2);
                                tab2.addWindowListener(new WindowAdapter() {
                      public void windowClosing(WindowEvent e) {System.exit(0);}
                      });
                                tab2.setVisible(true);
                                tab2.pack()	;
                                tab2.setLocation(100,100);
                  //------------------
                        Prop tab3= new Prop(fram,"n",3);
                                tab3.addWindowListener(new WindowAdapter() {
                      public void windowClosing(WindowEvent e) {System.exit(0);}
                      });
                                tab3.setVisible(true);
                                tab3.pack()	;
                                tab3.setLocation(100,100);
                 */
    
  }
  
  protected class MyFramstickListener implements FramstickListener
  {
    public void significantEdit(FramstickEvent framEvent)
    {
      update();
    }
    
    public void markChanged(FramstickEvent framEvent)
    {
      update();
    }
  }
}
