package fred;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.NoSuchElementException;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableColumn;
import javax.swing.text.html.*;

import jGDK.*;
import favi.Symbol;

/**
 * <p>Dialog window. User using this window can download and view and finally edit framsticks
 * stored in internet database.</p>
 * @author Damian Jarzebski
 * @version 1.0
 */
public class URLGens extends JDialog implements ActionListener, ListSelectionListener, HyperlinkListener
{
  
  private String TITLE = null;
  protected Vector pools;
  protected boolean isInApp = true;
  private boolean poolIsDown = false;
  public final static String BASE_ADDRESS = "www.alife.pl/fec/www/";
  final String POOL = "index.php?PAGE=browse_pools";
  final int REFRESH_TIME = 100;
  final String POOL_TAGS[] =
  { "FRED-POOL", "FRED-POOL-GENOCOUNT", "FRED-POOL-DESC", "FRED-LINK" };
  final String GENS_TAGS[] =
  { "FRED-NAME", "FRED-POOL", "FRED-AUTHOR", "FRED-INFO", "FRED-LINK", "FRED-PERF-NAME", "FRED-PERF" };
  final String TAB_NAMES[] =
  { "Name", "Pool", "Author", "Description" };
  private String address = BASE_ADDRESS + POOL;
  Vector perfName = new Vector();
  Framstick framstick = null;
  Framstick fram = new Framstick();
  Tazo2 tazo = null;
  Symbol symbol = null;
  Timer timer;
  protected Download download;
  String input = new String();
  boolean downloading = false;
  boolean framDown = false;
  
  JPanel jPList = new JPanel();
  JPanel jPTable = new JPanel();
  JSplitPane jPListSP = new JSplitPane();
  JSplitPane jMainSP = new JSplitPane();
  JPanel jPButtons = new JPanel();
  JPanel jLeftPanel = new JPanel();
  private DefaultListModel listModel = new DefaultListModel();
  JList jList1 = new JList(listModel);
  JScrollPane jScrollPane1 = new JScrollPane();
  JButton jBCancel = new JButton();
  JButton jBEdit = new JButton();
  JSplitPane jSplitPane1 = new JSplitPane();
  JSplitPane jSplitPane2 = new JSplitPane();
  JEditorPane jTextArea1 = new JEditorPane();
  JTable jTable1 = new JTable();
  JPanel jPDownload = new JPanel();
  JLabel jLabel1 = new JLabel();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JLabel jLabel2 = new JLabel();
  JProgressBar jProgressBar1 = new JProgressBar();
  JButton jBStop = new JButton();
  JLabel jLabel3 = new JLabel();
  GridBagLayout gridBLayout = new GridBagLayout();
  GridBagConstraints constr = new GridBagConstraints();
  private DataModel dm = new DataModel();
  //****************************************************************************************
  /**
   * <p>Description: Downloading Thread</p>
   */
  private static class Download extends Thread implements Runnable
  {
    String input;
    int progres;
    URL URLAddress;
    java.net.URLConnection uc;
    BufferedReader in;
    boolean running = false;
    public int maks = 0;
    /**
     * <p>Description: Downloading Thread Constructor</p>
     * @param address
     */
    public Download(String address) throws IOException
    {
      //      System.out.println("Downloading started");
      input = new String();
      progres = 0;
      URLAddress = new URL("http://" + address);
      String host = URLAddress.getHost();
      StringBuffer b = new StringBuffer(host);
      if ((b.indexOf(".html") >= 0) || (b.indexOf(".htm") >= 0) || (b.indexOf(".php") >= 0) || (b.indexOf(".cgi") >= 0))
        URLAddress = new URL("http://" + BASE_ADDRESS + address);
      else if (host.compareToIgnoreCase("http") == 0)
        URLAddress = new URL(address);
      else
      {
        if (host.compareToIgnoreCase("") == 0)
          URLAddress = new URL("http://" + BASE_ADDRESS + address);
        else if (URLAddress.getFile() == null)
          URLAddress = new URL("http://" + BASE_ADDRESS + address);
      }
      //      System.out.println("HOST: " + URLAddress.getHost() + "\nFILE: " + URLAddress.getFile());
      uc = URLAddress.openConnection();
      maks = uc.getContentLength();
      in = new BufferedReader(new InputStreamReader(uc.getInputStream()));
      running = true;
    }
    /**
     * <p>Description: Downloading Thread stoping function</p>
     */
    public void destroy()
    {
      if (running)
      {
        try
        {
          in.close();
          running = false;
          System.out.println("Downloading interupted");
        }
        catch (Exception exp)
        {
          System.out.println(exp.getMessage());
        };
      }
    }
    /**
     * <p>Description: Downloading Thread main function</p>
     */
    public void run()
    {
      try
      {
        if (!running)
          return;
        String inputLine;
        progres = 0;
        while ((inputLine = in.readLine()) != null)
        {
          input += inputLine + "\n";
          //System.out.println(inputLine);
          progres += inputLine.length();
          if (!running)
            return;
        };
        progres = maks;
        //        System.out.println("Downloading ended");
        in.close();
        running = false;
      }
      catch (Exception expt)
      {
        running = false;
        System.out.println("ERROR downloading: " + expt.getMessage());
      };
    }
  }
  /**
   * END OF Download CLASS
   */
  //	************************************************************************************
  /**
   * <p>Description: Genotype info class </p>
   */
  private class Gen
  {
    String name;
    String pool;
    String author;
    String info;
    String address;
    public Vector perfVal = new Vector();
    public Gen()
    {
      this.name = new String();
      this.pool = new String();
      this.author = new String();
      this.info = new String();
      this.address = new String();
    }
    public void tab(int poz, String arg)
    {
      if (poz == 0)
        this.name = arg;
      else if (poz == 1)
        this.pool = arg;
      else if (poz == 2)
        this.author = arg;
      else if (poz == 3)
        this.info = arg;
      else if (poz == 4)
        this.address = arg;
      //			else if (poz == 5)
      //				perfName.addElement(arg);
      else if (poz == 6)
        this.perfVal.addElement(arg);
    }
    public String get_tab(int poz)
    {
      if (poz == 0)
        return name;
      else if (poz == 1)
        return pool;
      else if (poz == 2)
        return author;
      else if (poz == 3)
        return info;
      else if (poz == 4)
        return address;
      else if (poz < 4 + this.perfVal.size()) //anyway this seems to be not prepared well for performances. needs improvement if performances are to be supported. - mac
        return (String)perfVal.elementAt(poz - 4);
      return new String("wrong table index");
    }
    public String toString()
    {
      return "--Gen Info--\n"
      + name
      + "\n"
      + pool
      + "\n"
      + author
      + "\n"
      + info
      + "\n"
      + "link: "
      + address
      + "\n"
      + ((perfName.size() > 0) ? perfName.elementAt(0).toString() : "")
      + ":"
      + ((perfVal.size() > 0) ? perfVal.elementAt(0).toString() : "")
      + "\n----------\n";
    }
  }
  protected class PoolsDesc
  {
    String name;
    String desc;
    String link;
    public PoolsDesc(String name, String description)
    {
      this.name = new String(name);
      this.desc = new String(description);
      this.link = new String();
    }
  }
  //	************************************************************************************
  /**
   * @param input
   * @return Pool Vector
   */
  protected Vector processPool(String input)
  {
    StringTokenizer st = new StringTokenizer(input, "<>");
    Vector result = new Vector();
    PoolsDesc desc = null;
    String token = new String();
    //    System.out.println("processing pools...");
    String s = "", tag = "";
    while (st.hasMoreTokens())
    {
      try
      {
        if ((token = st.nextToken()).compareToIgnoreCase("") != 0)
        {
          //System.out.println("pracuje..." + token);
          for (int i = 0; i < POOL_TAGS.length; i++)
          {
            if (token.compareToIgnoreCase(POOL_TAGS[i]) == 0)
            {
              //System.out.print("-->"+POOL_TAGS[i] + " :");
              s = "";
              tag = "";
              tag = st.nextToken();
              while (tag.compareToIgnoreCase("/" + POOL_TAGS[i]) != 0)
              {
                if ((tag.charAt(0) == 'a') || (tag.charAt(0) == 'A'))
                  tag = "<" + tag + ">";
                if (tag.compareToIgnoreCase("/A") == 0)
                  tag = "<" + tag + ">";
                if (tag.compareToIgnoreCase("BR") == 0)
                  tag = "<" + tag + ">";
                if ((tag.compareToIgnoreCase("P") == 0) || (tag.compareToIgnoreCase("/P") == 0))
                  tag = "<" + tag + ">";
                s += tag;
                tag = st.nextToken();
              }
              //System.out.println(s);
              if (i == 0)
                desc = new PoolsDesc(s, "");
              if (i == 1)
                desc.name+=" ("+s+")"; //genotypes count
              if (i == 2)
                desc.desc = s;
              if (i == 3)
              {
                StringTokenizer st2 = new StringTokenizer(s, "'\"");
                String string = null;
                string = st2.nextToken();
                string = st2.nextToken();
                s = string;
                desc.link = s+"&PER_PAGE=0";
                result.add(desc);
              }
            }
          }
        }
      }
      catch (NoSuchElementException nsee)
      {
        System.out.println("ERROR: Broken file: " + nsee);
        return result;
      }
    }
                /*				System.out.println("Wynik:");
                                                  for (int i = 0; i < result.size(); i++)
                                                          System.out.println(result.elementAt(i));
                                                  System.out.println("KONIEC");
                 */
    return result;
  }
  //	************************************************************************************
  /**
   * <p>Description: This function process the input www page.</p>
   * @param input
   * @return
   */
  private Vector processGenotypes(String input)
  {
    StringTokenizer st = new StringTokenizer(input, "<>");
    Vector result = new Vector();
    Gen gen = new Gen();
    String token = new String();
    //    System.out.println("processing genotypes list...");
    String s = "", tag = "";
    while (st.hasMoreTokens())
    {
      try
      {
        if ((token = st.nextToken()).compareToIgnoreCase("") != 0)
        {
          //System.out.println("pracuje..." + token);
          for (int i = 0; i < GENS_TAGS.length; i++)
          {
            if (token.compareToIgnoreCase(GENS_TAGS[i]) == 0)
            {
              s = "";
              tag = "";
              //System.out.print("-->"+GENS_TAGS[i] + " :");
              tag = st.nextToken();
              while (tag.compareToIgnoreCase("/" + GENS_TAGS[i]) != 0)
              {
                if (tag.compareToIgnoreCase("BR") == 0)
                  tag = "\n";
                s += tag;
                tag = st.nextToken();
              }
              //System.out.println(s);
              if (i == 4)
              {
                StringTokenizer st2 = new StringTokenizer(s, "'\"");
                String string = null;
                string = st2.nextToken();
                string = st2.nextToken();
                s = string;
              }
              else if (i == 0)
                gen = new Gen();
              if (i == 4)
              {
                result.add(gen);
                //System.out.println(gen);
              }
              else if (i == 5)
              {
                perfName.addElement(s);
                //System.out.println(">>>>>>>>>>dodaje<<<<<<<<<<<<");
              }
              //							else if(i==8){
              //								gen.perfVal.addElement(s);
              //							}
              gen.tab(i, s);
            }
          }
        }
      }
      catch (NoSuchElementException nsee)
      {
        System.out.println("ERROR: Broken file: " + nsee);
        return result;
      }
    }
                /*				System.out.println("Wynik:");
                                                  for (int i = 0; i < result.size(); i++)
                                                          System.out.println(((Gen) result.elementAt(i)));
                                System.out.println("naglowki:");
                                for (int i = 0; i < perfName.size(); i++)
                                                                          System.out.println(perfName.elementAt(i));
                                                  System.out.println("KONIEC");
                 */
    return result;
  }
  //	************************************************************************************
  /**
   * <p>Description: Table data model</p>
   */
  private class DataModel extends AbstractTableModel
  {
    Vector data = new Vector();
    public void reread()
    {
      perfName.removeAllElements();
      data = processGenotypes(input);
      this.fireTableStructureChanged(); //fireTableDataChanged();
    }
    public DataModel()
    {
      super();
      reread();
    }
    public int getRowCount()
    {
      return data.size();
    }
    public int getColumnCount()
    {
      return TAB_NAMES.length + perfName.size();
    }
    public Object getValueAt(int rowIndex, int columnIndex)
    {
      if (data.size() != 0)
        return ((Gen)data.elementAt(rowIndex)).get_tab(columnIndex);
      else
        return null;
    }
    public String getColumnName(int i)
    {
      if (i < TAB_NAMES.length)
        return TAB_NAMES[i];
      else
        return (String)perfName.elementAt(i - TAB_NAMES.length);
    }
    public Class getColumnClass(int c)
    {
      try
      {
        return getValueAt(0, c).getClass();
      }
      catch (NullPointerException e)
      {
        return null;
      }
    }
    public Object[] longValues()
    {
      Object lv[] = new Object[getColumnCount()];
      Object o = null;
      for (int i = 0; i < getColumnCount(); i++)
      {
        lv[i] = new Object();
        for (int k = 0; k < getRowCount(); k++)
        {
          o = getValueAt(k, i);
          if (o.getClass().toString().compareToIgnoreCase(lv[i].getClass().toString()) < 0)
            lv[i] = o;
        }
      }
      //	for (int i=0;i<getColumnCount();i++) System.out.println(lv[i]);
      return lv;
    }
  }
  private void initColumnSizes(JTable table, DataModel model)
  {
    TableColumn column = null;
    Component comp = null;
    int headerWidth = 0;
    int cellWidth = 0;
    Object[] longValues = model.longValues();
    
    for (int i = 0; i < table.getColumnCount(); i++)
    {
      column = table.getColumnModel().getColumn(i);
      
      comp = table.getDefaultRenderer(model.getColumnClass(i)).getTableCellRendererComponent(table, longValues[i], false, false, 0, i);
      cellWidth = comp.getPreferredSize().width;
      
      column.setPreferredWidth(Math.max(headerWidth, cellWidth));
    }
  }
  //	************************************************************************************
  /**
   * Constructor
   * @throws HeadlessException
   */
  public URLGens(Framstick f) throws HeadlessException
  {
    TITLE = I18N.getMessage("DownloadGen");
    this.framstick = f;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  //	************************************************************************************
  /**
   * main function
   */
  public static void main(String[] args) throws HeadlessException
  {
    I18N in = new I18N("", "");
    ErrManager err = new ErrManager();
    Library library = null;
    //jGDK-----------
    try
    {
      File f = new File("jGDK/model.def");
      if (!f.exists())
      {
        System.out.println("The config file don't exist: " + "model.def");
        return;
      }
      if (!f.canRead())
      {
        System.out.println("There is no access to the config file: " + "model.def");
        return;
      }
      InputStream input = new FileInputStream(f);
      int n = input.available();
      byte buf[] = new byte[n];
      if ((n = input.read(buf)) >= 0)
      {
        System.out.println("The config file has been read");
      }
      input.close();
      library = new Library(new String(buf));
    }
    catch (IOException ex)
    {
      System.out.println("ERROR: " + ex);
    }
    Framstick.library = library;
    GenotypeParser.library = library;
    //jGDK-----------END
    URLGens URLGens1 = new URLGens(new Framstick());
    URLGens1.isInApp = false;
    URLGens1.pack();
    URLGens1.show();
  } //end of main function
  //	************************************************************************************
  private void jbInit() throws Exception
  {
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setBounds(d.width/10, d.height/10, d.width*8/10, d.height*8/10);
    this.setModal(true);
    addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        if (isInApp)
        {
          dispose();
        }
        else
        {
          System.exit(0);
        }
      }
    });
    this.setTitle(TITLE);
    
    //Download panel
    jPDownload.setLayout(new GridLayout());
    jLabel3.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel3.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel3.setText(I18N.getMessage("DownloadPoolList")+":");
    jLabel3.setBounds(new Rectangle(5, 8, 145, 15));
    jProgressBar1.setStringPainted(true);
    jProgressBar1.setBounds(new Rectangle(5, 25, 150, 16));
    jProgressBar1.setBorder(new BevelBorder(BevelBorder.LOWERED));
    jBStop.setBounds(new Rectangle(165, 15, 73, 25));
    jBStop.setText(I18N.getMessage("Stop"));
    jBStop.setActionCommand("Stop");
    jBStop.setEnabled(false);
    jBStop.addActionListener(this);
    jPDownload.add(jLabel3);
    jPDownload.add(jProgressBar1);
    jPDownload.add(jBStop);
    
    //List panel
    GridBagLayout gbl = new GridBagLayout();
    jPList.setLayout(gbl);
    jPTable.setLayout(gbl);
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText(I18N.getMessage("GenPools")+":");
    jLabel2.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel2.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel2.setText(I18N.getMessage("Genotypes")+":");
    jList1.setPreferredSize(new Dimension(30, 100));
    jList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jList1.addListSelectionListener(this);
    jList1.setToolTipText(I18N.getMessage("SelectPoolToDownload"));
    
    TableSorter sorter = new TableSorter(dm);
    jTable1 = new JTable(sorter);
    sorter.addMouseListenerToHeaderInTable(jTable1);
    jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    jTable1.setColumnSelectionAllowed(false);
    jTable1.setRowSelectionAllowed(true);
    jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jTable1.getSelectionModel().addListSelectionListener(this);
    jTable1.setToolTipText(I18N.getMessage("ToEditOrView"));
    
    jScrollPane1.setPreferredSize(new Dimension(150, 70));
    jScrollPane1.getViewport().add(jTable1, null);
    
    constr.fill = GridBagConstraints.BOTH;
    constr.gridx = 0;
    constr.gridy = 0;
    constr.ipadx = 0;
    constr.ipady = 0;
    constr.weightx = 0;
    constr.weighty = 0;
    
    gbl.setConstraints(jLabel1, constr);
    jPList.add(jLabel1);
    jPList.setMinimumSize(new Dimension(5, 50));
    gbl.setConstraints(jLabel2, constr);
    jPTable.add(jLabel2);
    constr.gridx = 0;
    constr.gridy = 1;
    constr.weightx = 0.2;
    constr.weighty = 0.2;
    gbl.setConstraints(jList1, constr);
    jPList.add(jList1);
    constr.gridy = 1;
    constr.weightx = 0.7;
    constr.weighty = 0.7;
    gbl.setConstraints(jScrollPane1, constr);
    jPTable.add(jScrollPane1);
    jPListSP.setContinuousLayout(true);
    jPListSP.add(jSplitPane2, JSplitPane.TOP);
    jPListSP.add(jPTable, JSplitPane.BOTTOM);
    jPListSP.setResizeWeight(0.2);
    jPListSP.setBorder(new BevelBorder(BevelBorder.LOWERED));
    
    //Buttons panel
    jPButtons.setLayout(new GridLayout());
    jBCancel.setText(I18N.getMessage("Cancel"));
    jBCancel.setActionCommand("Cancel");
    jBCancel.addActionListener(this);
    jBCancel.setBorder(new BevelBorder(BevelBorder.RAISED));
    jBEdit.setText(I18N.getMessage("Edit"));
    jBEdit.setActionCommand("Edit");
    jBEdit.setEnabled(false);
    jBEdit.setBorder(new BevelBorder(BevelBorder.RAISED));
    jBEdit.addActionListener(this);
    jPButtons.add(jBCancel, null);
    jPButtons.add(jBEdit, null);
    jPButtons.setBorder(new BevelBorder(BevelBorder.LOWERED));
    
    jTextArea1.setPreferredSize(new Dimension(100, 100));
    jTextArea1.setText("");
    HTMLEditorKit ek = new HTMLEditorKit();
    jTextArea1.setEditorKit(ek);
    jTextArea1.setEditable(false);
    jTextArea1.addHyperlinkListener(this);
    jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
    jSplitPane1.setContinuousLayout(true);
    jSplitPane1.setResizeWeight(0.5);
    jSplitPane2.setResizeWeight(0.5);
    jSplitPane2.setContinuousLayout(true);
    jSplitPane2.setOrientation(JSplitPane.VERTICAL_SPLIT);
    tazo = new Tazo2(fram);
    tazo.setPreferredSize(new Dimension(100, 100));
    symbol = new Symbol(fram);
    symbol.setPreferredSize(new Dimension(100, 100));
    
    jSplitPane2.add(jPList, JSplitPane.TOP);
    jSplitPane2.add(jTextArea1, JSplitPane.BOTTOM);
    
    jSplitPane1.add(symbol, JSplitPane.TOP);
    jSplitPane1.add(tazo, JSplitPane.BOTTOM);
    
    jSplitPane1.setDividerLocation((double)0.5);
    jSplitPane2.setDividerLocation((double)0.5);
    
    jLeftPanel.setLayout(gridBLayout);
    constr.gridx = 0;
    constr.gridy = 0;
    constr.weightx = 0;
    constr.weighty = 0;
    gridBLayout.setConstraints(jPDownload, constr);
    jLeftPanel.add(jPDownload);
    constr.gridx = 0;
    constr.gridy = 1;
    constr.weightx = 0.1;
    constr.weighty = 0.1;
    gridBLayout.setConstraints(jPListSP, constr);
    jLeftPanel.add(jPListSP);
    constr.gridx = 0;
    constr.gridy = 2;
    constr.ipadx = 0;
    constr.gridheight = 1;
    constr.weightx = 0;
    constr.weighty = 0;
    gridBLayout.setConstraints(jPButtons, constr);
    jLeftPanel.add(jPButtons);
    
    jMainSP.add(jLeftPanel, JSplitPane.TOP);
    jMainSP.add(jSplitPane1, JSplitPane.BOTTOM);
    jMainSP.setDividerLocation((double)0.5);
    jMainSP.setContinuousLayout(true);
    this.getContentPane().add(jMainSP);
    
    jBStop.setActionCommand("Stop");
    jBStop.setEnabled(true);
    jBStop.setBorder(new BevelBorder(BevelBorder.RAISED));
    this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
    //-------------------------------------
    jProgressBar1.setMinimum(0);
    jProgressBar1.setMaximum(100);
    try
    {
      download = new Download(address);
    }
    catch (IOException e1)
    {
      JOptionPane.showMessageDialog(this, I18N.getMessage("CannotDownloadBecouse") + e1, I18N.getMessage("CannotDownload"), JOptionPane.ERROR_MESSAGE);
      //e1.printStackTrace();
      jLabel3.setText(I18N.getMessage("Download")+":");
      return;
    }
    jLabel3.setText(I18N.getMessage("DownloadingPool"));
    downloading = true;
    timer = new Timer(REFRESH_TIME, new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {
        jProgressBar1.setMaximum(download.maks);
        input = download.input;
        //reread of downloaded data
        pools = processPool(input);
        listModel.clear();
        for (int i = 0; i < pools.size(); i++)
          listModel.addElement(((PoolsDesc)pools.get(i)).name);
        jProgressBar1.setValue(download.progres);
        jProgressBar1.setString(download.progres / 1024 + (download.maks>0? " / "+download.maks/1024 : "") + " KB");
        if (!download.running)
        {
          timer.stop();
          downloading = false;
          if (pools.size() > 0)
          {
            //jList1.setSelectedIndex(0);
            address = ((PoolsDesc)pools.get(0)).link;
            poolIsDown = true;
          }
          jLabel3.setText(I18N.getMessage("DownloadGens")+":");
          jBStop.setEnabled(false);
        }
      }
    });
    timer.start();
    download.start();
    //-------------------------------------
  }
  //	************************************************************************************
  private String[] processGenotype(String input)
  {
    if (input.equalsIgnoreCase(""))
    {
      return null;
    }
    else
    {
      String[] tab =
      {
        I18N.getMessage("unknownAuthor"),
        I18N.getMessage("unknownName"),
        I18N.getMessage("noInfo"),
        "//0"
      };
      StringTokenizer st = new StringTokenizer(input, "<>");
      String token;
      while (st.hasMoreTokens())
      {
        token = st.nextToken();
        if (token.equalsIgnoreCase("FRED-AUTHOR"))
          tab[0] = st.nextToken();
        else if (token.equalsIgnoreCase("FRED-NAME"))
          tab[1] = st.nextToken();
        else if (token.equalsIgnoreCase("FRED-INFO"))
          tab[2] = st.nextToken();
        else if (token.equalsIgnoreCase("FRED-NOTES"))
          tab[2] += "\n\nNotes:\n"+st.nextToken();
        else if (token.toUpperCase().startsWith("!--FRED_GEN"))
        {
          tab[3] = token.replace('~', '\n').substring(11, token.length() - 2); //what for replace '~' ?
        }
      }
      return tab;
    }
  }
  /**
   * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
   */
  public void actionPerformed(ActionEvent e)
  {
    //Toolkit.getDefaultToolkit().beep();
    if (e.getActionCommand().compareTo("Edit") == 0)
    {
      if (jTable1.getRowCount() > 0)
      {
        if (!framDown)
        {
          address = ((Gen)dm.data.get(jTable1.getSelectedRow())).address;
          jLabel3.setText("Downloading...");
          jProgressBar1.setMinimum(0);
          jProgressBar1.setMaximum(100);
          try
          {
            download = new Download(address);
          }
          catch (IOException e1)
          {
            JOptionPane.showMessageDialog(this, "Cannot download this file because of:\n" + e1, "Cannot download file", JOptionPane.ERROR_MESSAGE);
            //e1.printStackTrace();
            jLabel3.setText("Download:");
            return;
          }
          download.start();
          downloading = true;
          timer = new Timer(REFRESH_TIME, new ActionListener()
          {
            public void actionPerformed(ActionEvent evt)
            {
              jProgressBar1.setMaximum(download.maks);
              jProgressBar1.setValue(download.progres);
              jProgressBar1.setString(download.progres / 1024 + (download.maks>0? " / "+download.maks/1024 : "") + " KB");
              if (!download.running)
              {
                timer.stop();
                input = download.input;
                downloading = false;
                jBStop.setEnabled(false);
                Vector v = processGenotypes(input);
                String[] tab = processGenotype(input);
                if (tab == null)
                {
                  jBStop.setEnabled(false);
                  return;
                }
                framstick.author = tab[0];
                framstick.name = tab[1];
                framstick.info = tab[2];
                framstick.genotype = tab[3];
                jTextArea1.setText("Description: "+tab[2]);
                framstick.rebuildModel();
                framstick.fireSignificantEditEvent();
                //framstick.fireMarkChangedEvent();
                jBCancel.doClick();
              }
            }
          }
          );
          timer.start();
        }
        else
        {
          framstick.author = fram.author;
          framstick.name = fram.name;
          framstick.info = fram.info;
          framstick.genotype = fram.genotype;
          framstick.rebuildModel();
          framstick.fireSignificantEditEvent(); //not sure if needed, just added as above - seemed to be missing
          jBCancel.doClick();
        }
      }
    }
    else if (e.getActionCommand().compareTo("View") == 0)
    {
      if (jTable1.getRowCount() > 0)
      {
        address = ((Gen)dm.data.get(jTable1.getSelectedRow())).address;
        jLabel3.setText("Downloading...");
        jProgressBar1.setMinimum(0);
        jProgressBar1.setMaximum(100);
        try
        {
          download = new Download(address);
        }
        catch (IOException e1)
        {
          JOptionPane.showMessageDialog(this, "Cannot download this file because of:\n" + e1, "Cannot download file", JOptionPane.ERROR_MESSAGE);
          //e1.printStackTrace();
          jLabel3.setText("Download:");
          return;
        }
        download.start();
        downloading = true;
        timer = new Timer(REFRESH_TIME, new ActionListener()
        {
          public void actionPerformed(ActionEvent evt)
          {
            jProgressBar1.setMaximum(download.maks);
            jProgressBar1.setValue(download.progres);
            jProgressBar1.setString(download.progres / 1024 + (download.maks>0? " / "+download.maks/1024 : "") + " KB");
            if (!download.running)
            {
              timer.stop();
              input = download.input;
              downloading = false;
              jBStop.setEnabled(false);
              Vector v = processGenotypes(input);
              String[] tab = processGenotype(input);
              if (tab == null)
              {
                jBStop.setEnabled(false);
                return;
              }
              fram.author = tab[0];
              fram.name = tab[1];
              fram.info = tab[2];
              fram.genotype = tab[3];
              jTextArea1.setText("Description: "+tab[2]);
              //-----------------
              fram.rebuildModel();
	      // brakowalo tu fire event, ale to nie wszystko.
	      fram.fireSignificantEditEvent();
	      // wydawaloby sie, ze fire event powinien wszystko zrobic
	      // ale jednak kamery (chyba) nie ustawia, wiec:
	      tazo.defaultCameraPos();
	      /* za to robi inne rzeczy, ktore tu wczesniej byly:
	       *
              symbol.setNeuronsPos(); //poczatkowe ustawienie
              symbol.setZoomValue();
              symbol.repaint();
              tazo.buildCenter();
              //budujemy srodek sceny (tam kierujemy kamere)
              tazo.prepareScene();
              //podstawowe ustawienia sceny
              tazo.createLights();
              //utworzenie zrodel swiatla
              tazo.addObjectsToScene();
              //dodanie obiektow do sceny
              tazo.redrawScene();
              tazo.repaint();
	       */
              //------------------
              for (int x = 0; x < ErrManager.msg.size(); x++)
                System.out.println("--> " + (Message)ErrManager.msg.get(x));
              ErrManager.msg.clear();
              //jBStop.setText("Start");
              jLabel3.setText("Download:");
              jBStop.setEnabled(true);
            }
          }
        });
        timer.start();
      }
    }
    else if (e.getActionCommand().compareTo("Cancel") == 0)
    {
      if (isInApp)
      {
        dispose();
      }
      else
      {
        System.exit(0);
      }
    }
    else if (e.getActionCommand().compareTo("Stop") == 0)
    {
      if (downloading)
      {
        download.destroy();
        jLabel3.setText("Download:");
        if (poolIsDown)
        {
          dm.reread();
        }
        else
        {
          pools = processPool(input);
          listModel.clear();
          for (int i = 0; i < pools.size(); i++)
            listModel.addElement(((PoolsDesc)pools.get(i)).name);
        }
        downloading = false;
        initColumnSizes(jTable1, dm);
        //jBStop.setText("Start");
      }
      
    }
    else if (e.getActionCommand().compareTo("Start") == 0)
    {
      if (!downloading)
      {
        jLabel3.setText("Downloading...");
        jProgressBar1.setMinimum(0);
        jProgressBar1.setMaximum(100);
        try
        {
          download = new Download(address);
        }
        catch (IOException e1)
        {
          JOptionPane.showMessageDialog(this, "Cannot download this file because of:\n" + e1, "Cannot download file", JOptionPane.ERROR_MESSAGE);
          //e1.printStackTrace();
          jLabel3.setText("Download:");
          jBStop.setActionCommand("Stop");
          jBStop.setEnabled(false);
          return;
        }
        download.start();
        downloading = true;
        timer = new Timer(REFRESH_TIME, new ActionListener()
        {
          public void actionPerformed(ActionEvent evt)
          {
            jProgressBar1.setMaximum(download.maks);
            input = download.input;
            //reread of downloaded data
            if (poolIsDown)
            {
              dm.reread();
            }
            else
            {
              pools = processPool(input);
              listModel.clear();
              for (int i = 0; i < pools.size(); i++)
                listModel.addElement(((PoolsDesc)pools.get(i)).name);
            }
            jProgressBar1.setValue(download.progres);
            jProgressBar1.setString(download.progres / 1024 + (download.maks>0? " / "+download.maks/1024 : "") + " KB");
            if (!download.running)
            {
              timer.stop();
              if (!poolIsDown)
              {
                if (pools.size() > 0)
                {
                  jList1.setSelectedIndex(0);
                  address = ((PoolsDesc)pools.get(0)).link;
                  poolIsDown = true;
                  jLabel3.setText("Download pools list:");
                }
                else
                  jLabel3.setText("Download genotypes list:");
              }
              downloading = false;
              jLabel3.setText("Download:");
              jBStop.setEnabled(false);
              //jBStop.setText("Start");
            }
          }
        });
        timer.start();
        jBStop.setActionCommand("Stop");
      }
    }
  }
  //************************************************************************************
  /**
   * refresing the table with framsticks informations,.
   * @see javax.swing.event.ListSelectionListener#valueChanged(javax.swing.event.ListSelectionEvent)
   */
  public void valueChanged(ListSelectionEvent e)
  {
    jBStop.setText(I18N.getMessage("Stop"));
    jBStop.setActionCommand("Stop");
    jBEdit.setEnabled(false);
    int index = 0;
    //jList
    if (e.getSource() == jList1)
    {
      if (!downloading)
        if (!e.getValueIsAdjusting())
        {
          jLabel3.setText("Download genotypes list:");
          index = jList1.getSelectedIndex();
          if (index < 0)
            return;
          if (pools.size() != 0)
          {
            jTextArea1.setText(((PoolsDesc)pools.get(index)).desc);
            address = ((PoolsDesc)pools.get(index)).link;
          }
          jBStop.setActionCommand("Start");
          jBStop.setEnabled(true);
          perfName.removeAllElements();
          jBStop.doClick();
        }
    }
    //jTable
    if (e.getSource() == jTable1.getSelectionModel())
    {
      if (!e.getValueIsAdjusting())
      {
        index = jTable1.getSelectedRow();
        if (index < 0)   return;
        if (dm.data.size() > 0)
        {
          this.setTitle(TITLE + " - "+I18N.getMessage("PleaseWait"));
          address = ((Gen)this.dm.data.get(index)).address;
                                /*					fram.genotype = ((Gen)this.dm.data.get(index)).gen;
                                                                        fram.name = ((Gen)this.dm.data.get(index)).name;
                                                                        fram.author = ((Gen)this.dm.data.get(index)).author;
                                                                        fram.info = ((Gen)this.dm.data.get(index)).info;
                                                                        fram.rebuildModel();
                                                                        symbol.setNeuronsPos(); //poczatkowe ustawienie
                                                                        symbol.setZoomValue();
                                                                        symbol.repaint();
                                                                        tazo.buildCenter();
                                                                        //budujemy srodek sceny (tam kierujemy kamere)
                                                                        tazo.prepareScene(); //podstawowe ustawienia sceny
                                                                        tazo.createLights(); //utworzenie zrodel swiatla
                                                                        tazo.addObjectsToScene(); //dodanie obiektow do sceny
                                                                        tazo.redrawScene();
                                                                        tazo.repaint();
                                 */
          jBStop.setText("View");
          jBStop.setActionCommand("View");
          jBStop.setEnabled(true);
          jBStop.doClick();
          jBEdit.setEnabled(true);
          this.setTitle(TITLE);
        }
        //if(address.compareToIgnoreCase("")!=0) jBStop.setEnabled(true);
      }
    }
  }
  /**
   * Enbling user to go were link does.
   * @see javax.swing.event.HyperlinkListener#hyperlinkUpdate(javax.swing.event.HyperlinkEvent)
   */
  public void hyperlinkUpdate(HyperlinkEvent e)
  {
    if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
    {
      JEditorPane pane = (JEditorPane)e.getSource();
      if (e instanceof HTMLFrameHyperlinkEvent)
      {
        HTMLFrameHyperlinkEvent evt = (HTMLFrameHyperlinkEvent)e;
        HTMLDocument doc = (HTMLDocument)pane.getDocument();
        doc.processHTMLFrameHyperlinkEvent(evt);
      }
      else
      {
        try
        {
          pane.setPage(e.getURL());
        }
        catch (Throwable t)
        {
          System.out.println("Cannot resolve address: " + t);
          //t.printStackTrace();
        }
      }
    }
  }
  protected void finalize() throws Throwable
  {
    this.getContentPane().removeAll();
    jBStop.removeActionListener(this);
    TITLE = null;
    pools = null;
    address = null;
    perfName = null;
    framstick = null;
    fram = null;
    tazo = null;
    symbol = null;
    timer = null;;
    download = null;
    input = null;
    jPList = null;
    jPTable = null;
    jPListSP = null;
    jMainSP = null;
    jPButtons = null;
    jLeftPanel = null;
    listModel  = null;
    jList1  = null;
    jScrollPane1 = null;
    jBCancel = null;
    jBEdit = null;
    jSplitPane1 = null;
    jSplitPane2 = null;
    jTextArea1 = null;
    jTable1 = null;
    jPDownload = null;
    jLabel1 = null;
    gridBagLayout2 = null;
    jLabel2 = null;
    jProgressBar1 = null;
    jBStop = null;
    jLabel3 = null;
    gridBLayout = null;
    constr = null;
    dm = null;
    super.finalize();
  }
}
