package jGDK;

import java.util.*;
/**
 * <p>Title: Fred v.2.0 - Joint.java</p>
 * @author Piotr Jankowski
 * @version 2.0
 */
public class Joint extends Element {

	Hashtable properties;

	Joint(Hashtable brandnew) 
	{
		properties= new Hashtable(brandnew);
	}

	Joint(Joint n) 
	{
		this.properties=new Hashtable(n.properties);
	}

	public String toString()
	{
		String ret = new String("j:"); 	
    	Enumeration k = this.properties.keys();
		Enumeration e = this.properties.elements();
		while(k.hasMoreElements())
			ret +=k.nextElement()+"="+e.nextElement()+",";
		if (ret.length()==2)
      		return ret;
    	else
      		return ret.substring(0,ret.length()-1);
	}
	
	/**
   	* calculates position of p2 Part
   	* @param vParts vector of all Parts
	*/
	public Part calcPosition(final Vector vParts)
  	{
    	int p1 = ((Integer)this.properties.get("p1")).intValue();
    	int p2 = ((Integer)this.properties.get("p2")).intValue();
    	Part p1Part = (Part)vParts.elementAt(p1);
    	Part p2Part = (Part)vParts.elementAt(p2);
    	float dX = 0;
    	float dY = 0;
    	float dZ = 0;
    	float rX = 0;
    	float rY = 0;
    	float rZ = 0;
    	
		if (properties.containsKey("dx")) dX=((Float)properties.get("dx")).floatValue();
		if (properties.containsKey("dy")) dY=((Float)properties.get("dy")).floatValue();
		if (properties.containsKey("dz")) dZ=((Float)properties.get("dz")).floatValue();
		if (properties.containsKey("rx")) rX=((Float)properties.get("rx")).floatValue();
		if (properties.containsKey("ry")) rY=((Float)properties.get("ry")).floatValue();
		if (properties.containsKey("rz")) rZ=((Float)properties.get("rz")).floatValue();
    	float p1x = 0;
    	if (p1Part.properties.containsKey("x")) p1x=((Float)p1Part.properties.get("x")).floatValue();
    	float p1y = 0;
    	if (p1Part.properties.containsKey("y")) p1y=((Float)p1Part.properties.get("y")).floatValue();
    	float p1z = 0;
    	if (p1Part.properties.containsKey("z")) p1z=((Float)p1Part.properties.get("z")).floatValue();
	    Part resPart = new Part(p2Part);
	    resPart.setOrientation();
	    Orient3d o=new Orient3d(); 
		o.rotate(rX,rY,rZ);
		p1Part.o.transform(resPart.o.m,o.m);
		float xyz[]=new float[]{dX,dY,dZ};
    	float rotated[]=resPart.o.transform(xyz);
    	if (properties.containsKey("dx")) 
    	{
    	   	resPart.properties.put("x",new Float(p1x+rotated[0]));
    		resPart.properties.put("y",new Float(p1y+rotated[1]));
    		resPart.properties.put("z",new Float(p1z+rotated[2]));
 		
    	}
    		else
    	{	
    		if (rX!=0||rY!=0||rZ!=0)
    		{
    			resPart.properties.put("x",new Float(p1x));
    			resPart.properties.put("y",new Float(p1y));
    			resPart.properties.put("z",new Float(p1z));
    		}
    	}
 	
	
	 	//important:part which is parent to another can't change position due to delta joint translation!!!
 		if ((p2Part.parent==true||p2Part.child==true)&&properties.containsKey("dx")) 
 		{
			Object inon[]={""+p1,""+p2};		
	/*M*/	ErrManager.send(I18N.getMessage("modeModel"), ErrManager.ER_ERROR, I18N.getFormated("joinBroken",inon));
				
 			if (this.properties.containsKey("dx")) this.properties.put("dx",new Float(0.0));
 			return p2Part;
 		}
    	return resPart;
    	
    
  }



}
